#ifndef __LCD__GEMISCHT__ZUSATZ
  #define __LCD__GEMISCHT__ZUSATZ
  #include <avr/io.h>
  #include <util/delay.h>

/* Einstellungen */
  #define PORT_LCDD PORTD
  #define DDR_LCDD DDRD
  #define PIN_LCDD PIND

  #define PORT_LCDC PORTB
  #define DDR_LCDC DDRB
  #define PIN_LCDC PINB
  #define LCD_EN PB0
  #define LCD_RW PB4
  #define LCD_RS PB5

  #define LONGDELAY  _delay_ms(5);
  #define SHORTDELAY _delay_ms(1);
  // Zusaetzliche Konstanten fuer Hilfsfunktionen 
  #define CLEARCOMMAND 0x01
  #define DISPLAYLENGTH 16
  #define DISPLAYHEIGHT 2
  #define DISPADRESSABST 0x40  

  

/* Funktionen */
  void lcd_putini4(char kommando);  // Halbbytes ans LCD uebergeben     (4 Bit)
  void lcd_putcom4(char kommando);  // Kommandos an LCD uebergeben      (4 Bit)
  void lcd_putdat4(char zeichen);   // Zeichen an LCD ausgeben          (4 Bit)
  void lcd_init4();                 // Initialisieren                   (4 Bit)

  void lcd_putcom8(char kommando);  // Kommandos an LCD uebergeben      (8 Bit)
  void lcd_putdat8(char zeichen);   // Zeichen an LCD ausgeben          (8 Bit)
  void lcd_init8();                 // Initialisieren                   (8 Bit)

  void lcd_pos4(int posX, int posY);// Cursor auf Position X, Y bewegen (4 Bit) 
  void lcd_clear4();                // Inhalt des Displays loeschen     (4 Bit)
  void lcd_putstr4(char *zeichenkette); // String ausgeben              (4 Bit)

  void lcd_pos8(int posX, int posY);// Cursor auf Position X, Y bewegen (8 Bit) 
  void lcd_clear8();                // Inhalt des Displays loeschen     (8 Bit)
  void lcd_putstr8(char *zeichenkette); // String ausgeben              (8 Bit)

#endif







