/* USART-Funktionen fr ATmega168
   nur fr Testplatine */

#include "usart.h"
#include <avr/io.h>



// USART initialisieren 
void usart_init(void)
{
 unsigned char x;                      // Hilfsvariable
 UBRR0H = UBBR_SELECT >> 8;            // Baudratenregister
 UBRR0L = UBBR_SELECT;                 // Baudrate
 UCSR0B |= (1 << TXEN0) | (1 << RXEN0);// Sender und Empfnger ein
 UCSR0B |= (1 << RXCIE0);              // Empfnger-Interrupt ein
 x = UDR0;                             // Empfnger leeren
 while ( !(UCSR0A & (1 << RXC0) ));    // Warte bis Zeichen da
 while ( !(UCSR0A & (1 << UDRE0)) );   // Warten bis UART Data empty
}


//  Zeichen ber USART senden
void usart_putchar(char zeichen)
{
 loop_until_bit_is_set(UCSR0A, UDRE0); // warte bis Sender frei
 UDR0 = zeichen;
}


// Zeichenkette ber USART senden
void usart_putstr(char *zeichenkette)
{
  while (*zeichenkette)
  {
    usart_putchar(*zeichenkette);
    zeichenkette++;
  }
}
