/* Funktionen fuer die Ansteuerung von HD44780-kompatiblen
 * LCDs im 8-Bit-Modus
 */


#include <avr/io.h>
#include <util/delay.h>
#include "lcd8.h" 

// Enable-Puls
inline void lcd_enablepulse()
{
  asm volatile ("nop");                 // NACHTRAG
  PORT_LCDC |= (1 << LCD_EN);           // NACHTRAG
  asm volatile ("nop");                 // NACHTRAG
  PORT_LCDC &= ~(1 << LCD_EN);          // NACHTRAG
}


// Kommandos an LCD uebergeben
void lcd_putcom(char kommando)
{
  // Byte uebertragen
  PORT_LCDD = kommando;                 // NACHTRAG
                    
  lcd_enablepulse();                    // NACHTRAG  

  SHORTDELAY                            // NACHTRAG
}


// Zeichen an LCD ausgeben
void lcd_putchar(char zeichen)
{
  PORT_LCDC |=  (1 << LCD_RS);          // NACHTRAG
  lcd_putcom(zeichen);                  // NACHTRAG
  PORT_LCDC &=  ~(1 << LCD_RS);         // NACHTRAG
}



// LCD initialisieren 8 Bit
void lcd_init()
{
  // Pins auf Ausgang
  DDR_LCDD = 0xff;                      // NACHTRAG
  DDR_LCDC = (1 << LCD_EN) | (1 << LCD_RW) | (1 << LCD_RS); // NACHTRAG

  // Pins auf Low
  PORT_LCDD = 0x00;                     // NACHTRAG
  PORT_LCDC &= ~((1 << LCD_EN) | (1 << LCD_RW) | (1 << LCD_RS)); // NACHTRAG

  // Initialisierung starten
  lcd_putcom(0x30);                     // NACHTRAG
  LONGDELAY                             // NACHTRAG
  lcd_putcom(0x30);                     // NACHTRAG
  LONGDELAY                             // NACHTRAG
  lcd_putcom(0x30);                     // NACHTRAG
  LONGDELAY                             // NACHTRAG

  lcd_putcom(0b00111000);               // NACHTRAG
  LONGDELAY                             // NACHTRAG
  lcd_putcom(0x0C);                     // NACHTRAG
  LONGDELAY                             // NACHTRAG
  lcd_putcom(0x01);                     // NACHTRAG
  LONGDELAY                             // NACHTRAG
  lcd_putcom(0x06);                     // NACHTRAG
 
 // Noch ein wenig warten
  _delay_ms(5);                         
}



