/* Funktionen fuer die Ansteuerung von HD44780-kompatiblen
 * LCDs im 8-Bit-Modus
 */



// Einstellungen LCD
#define PORT_LCDD PORTD
#define DDR_LCDD DDRD
#define PIN_LCDD PIND

#define PORT_LCDC PORTB
#define DDR_LCDC DDRB
#define PIN_LCDC PINB
#define LCD_EN PB0
#define LCD_RW PB4
#define LCD_RS PB5

#define LONGDELAY  _delay_ms(5);
#define SHORTDELAY _delay_ms(1);

// Zusaetzliche Konstanten fuer Hilfsfunktionen 
#define CLEARCOMMAND 0x01
#define DISPLAYLENGTH 16
#define DISPLAYHEIGHT 2
#define DISPADRESSABST 0x40


// Kommandos an LCD uebergeben
void lcd_putcom(char kommando);

// Zeichen an LCD ausgeben
void lcd_putchar(char zeichen);

// LCD initialisieren 8 Bit
void lcd_init(void);

// Cursor auf Position X, Y bewegen   
void lcd_pos(int posX, int posY);

// Inhalt des Displays komplett loeschen 
void lcd_clear(void);

// Strings auf LCD ausgeben
void lcd_putstr(char *zeichenkette);




