/* Uebungsprogramm Mikrocontrollerseminar:
 * Ansteuerung eines HD44780-kompatiblen LCDs 4-Bit-Modus
 * Anschluss des LCDs wird in lcd4.h eingestellt.
 */

#ifndef F_CPU
  #define F_CPU 16000000UL
#endif

#include <avr/io.h> 
#include <util/delay.h>
#include "lcd4.h"


inline void warte10ms(int faktor)
{
	for (int i=faktor; i>0; i--)
	{
		_delay_ms(10);
	}
}


int main(void)
{
	// Entsprechende Pins auf Ausgang und LCD initialisieren
	lcd_init();                      

	// LCD loeschen
	lcd_clear();                     

	// Zeichen ausgeben: "LCD OK"
	lcd_putchar('L');                
	lcd_putchar('C');                
	lcd_putchar('D');                
	lcd_putchar(' ');                
	lcd_putchar('O');                
	lcd_putchar('K');                

	warte10ms(50);

	// In zweite Zeile erstes Zeichen 
	lcd_pos(0,1);                   

	// Zeichenkette schreiben
	lcd_putchar('4');
	lcd_putchar('-');
	lcd_putchar('B');
	lcd_putchar('i');
	lcd_putchar('t');



	while(1);

	return 1;
}
