#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "lcd4.h"


/*
 A/D-Wandler an PC3 = ADC3


 */

char cs[40];
int clock = 0;
 int main(void)
 {
  DDRC = 0x00;
  while (bit_is_set(ADCSRA, ADSC));

  char hilf = 0;
  hilf  |= (0 << MUX3) | (0 << MUX2) | (1 << MUX1) | (1 << MUX0); // Kanal ADC3

  hilf |=  (1 << REFS0);  // Referenzspannung: AVcc mit externem 
  hilf |=  (0 << REFS1);  // Kondensator an ARef (Datenblatt S. 256)
  
  hilf |=  (0 << ADLAR);  // Ergebnis linksbndig ausrichten

  ADMUX = hilf;

  hilf   = 0;             // Fr ADCSRB 
  hilf  |= (0<<ADTS2) | (0<<ADTS1) | (0<<ADTS0); // Free running mode.
  ADCSRB = hilf;

  hilf   = 0; // Fr ADCSRA
  // 16 MHz / 0,2 MHz = 80 -> Teilungsfaktor 128 (Datenblatt S. 258)
  // 16 MHz / 128 = 125 kHz ADC-Clock
  hilf  |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
  hilf  |= (1 << ADATE);  // Auto-Trigger nach ADTSx in ADCSRB
  hilf  |= (1 << ADEN);   // ADC einschalten
  hilf  |= (1 << ADSC);   // Wandlung starten

  ADCSRA = hilf;  

  DIDR0 |= (1 << ADC3D);  // Digitaler Input ADC4 aus






  // Entsprechende Pins auf Ausgang und LCD initialisieren
	lcd_init();                      

	// LCD loeschen
	lcd_clear();  
  
  lcd_putstr("Init OK");

  while(1)
  {
	//ADCSRA |= (1 << ADSC);

	// ADSC is cleared when the conversion finishes
	//while (bit_is_set(ADCSRA, ADSC));

	// we have to read ADCL first; doing so locks both ADCL
	// and ADCH until ADCH is read.  reading ADCL second would
	// cause the results of each conversion to be discarded,
	// as ADCL and ADCH would be locked when it completed.
	//char low = ADCL;
	//char high = ADCH;

	// combine the two bytes
	//int ergebnis = (high << 8) | low;
  int ergebnis = ADC;
  lcd_pos(0,0);
  snprintf(cs,40,"CK= %d",clock++);
	lcd_putstr(cs);
  // In zweite Zeile erstes Zeichen 
	lcd_pos(0,1);   

  snprintf(cs,40,"AD= %d     ",ergebnis);
	lcd_putstr(cs);

  }

 return 1;
 }
